#coding:utf-8
#内核调用，执行挂载可移动设备
#python3.4 automount.py -mount sdb1

import sys
import re
import os
import subprocess

#获取传入值
try:
    mathod = "mount"
    str_argv1 = sys.argv[1]
    if str_argv1 == "-mount":
        mathod = "mount"
    elif str_argv1 == "-umount":
        mathod = "umount"
    else:
        exit(0)
    str_argv2 = sys.argv[2]
    list_session = re.findall("([a-z]+)\d+", str_argv2)
    session = list_session[0]   #组
    name = str_argv2 #名
except IndexError:
    #print("list index out of range")
    exit(0)  

#创建挂载文件夹   
# if os.path.exists("/mnt/usb") is False:
#     os.system ("mkdir -p /mnt/usb")

#挂载操作
if mathod == "mount":   
    #sudo fdisk -l /dev/$1
    #查找U盘的数据类型
    cmd = "fdisk -l /dev/%s" % session
    ret = subprocess.Popen(cmd, shell=True, stdout = subprocess.PIPE)
    backtxt = ret.stdout.read()
    backtxt = bytes.decode(backtxt)
    
    findinfo = False    #是否成功找打
    USBType = "FAT32"   #U盘的数据类型
    for line in backtxt.split("\n"):
        str_info = re.findall("/dev/%s" % name, line)
        if len(str_info) > 0:
            findinfo = True
            if "NTFS" in line:
                USBType = "ntfs"
            elif "FAT32" in line:
                USBType = "vfat"
            else:
                findinfo = False
            break
    if findinfo is False:
        exit(0)
    
    cmd = "mount -t %s /dev/%s /opt" % (USBType, name)
    os.system(cmd)
    os.system("sync")
#卸载
elif mathod == "umount":
    cmd = "umount /opt"    
    os.system("sync")
    os.system(cmd)
            
            
            
            
            
            
        
        
        